﻿using System.Collections.Immutable;
using Connected.Annotations;
using Connected.ServiceModel;

namespace Connected.Configuration.Settings;

[Service]
[ServiceUrl(ConfigurationUrls.Settings)]
public interface ISettingsService
{
	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ISetting?> Select(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ISetting?> Select(NameArgs args);

	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<ISetting>> Query();

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Patch)]
	Task Update(SettingsArgs args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Delete)]
	Task Delete(PrimaryKeyArgs<int> args);
}
