﻿namespace Connected.Services;

public abstract class ServiceAction<TArgs> : ServiceOperation<TArgs>, IAction<TArgs>
	where TArgs : IDto
{
	public async Task Invoke(TArgs e)
	{
		Arguments = e;

		await OnInvoke();
	}

	protected virtual async Task OnInvoke()
	{
		await Task.CompletedTask;
	}
}
